;
;  D I S P L A Y 
;  -------------
;
;
; Pro rizeni sedmisegmentoveho displeje na pripravcich je pouzit
; obvod M5480B7. Obvod obsahuje posuvny registr a zachytny registr, jehoz
; vystupy primo ovladaji jednotlive segmentovky displeje. Data (to, co
; pozadujeme na displeji zobrazit) vstupuji do obvodu seriove pres bity
; P1.0 (hodiny) a P1.1 (seriova data). Jednotlive bity se zapisuji
; nabeznou hranou hodinoveho signalu.
;
; Seriova data maji konstantni delku 36 bitu. Prvni bit je vzdy jednickovy
; a ridi prepsani informace z posuvneho registru do zachytneho registru.
; K prepsani dojde tehdy, kdyz se tento bit dostane na konec posuvneho
; registru (tzn. kdyz vsech 36 bitu je jiz v posuvnem registru). Tim se
; zamezuje problikavani segmentu behem zapisu dat.
;
; Data maji nasledujici strukturu:
;
;      1 X g3 f3 e3 d3 c3 b3 a3  X X X g2 f2 e2 d2 X X ...
;      X X c2 b2 a2 g1 f1 e1  X d1 X X c1 b1 a1  X X X
;
; 1 - log. 1
; X - znamena: na tomto bitu nezalezi (muze byt 0 nebo 1).
; a,...,g - segmenty dle obr.
;
;
;   segmentovka 3    segmentovka 2    segmentovka 1
;   --------------   --------------   --------------
;  |       a3     | |      a2      | |       a1     |
;  |      ----    | |      ----    | |       ----   |
;  |  f3 /g3 / b3 | |  f2 /g2 / b2 | |  f1 /g1 / b1 |
;  |     ----     | |     ----     | |     ----     |
;  | e3 /   / c3  | | e2 /   / c2  | | e1 /   / c1  |
;  |    ----      | |    ----      | |    ----      |
;  |     d3       | |     d2       | |     d1       |
;   --------------   --------------   --------------
;
;       !!! DESETINNE TECKY NEJSOU ZAPOJENY !!!
;
; TVARY ZNAKU
;
; format: 
;                       | x | g | f | e | d | c | b | a |
;  napr.: char_0 = 3fh  | 0 | 0 | 1 | 1 | 1 | 1 | 1 | 1 |
;
; cisla
;
char_0     equ 3fh
char_1     equ 06h
char_2     equ 5bh
char_3     equ 4fh
char_4     equ 66h
char_5     equ 6dh
char_6     equ 7dh
char_7    equ 07h
char_8     equ 7fh
char_9     equ 6fh 
;
; pismena
;
char_A     equ 77h
char_b     equ 7ch
char_C     equ 39h
char_d     equ 5eh
char_E    equ 79h
char_F     equ 71h
char_H     equ 76h
char_J     equ 1Fh
char_L     equ 38h
char_n     equ 54h
char_o     equ 5ch
char_P     equ 63h
char_r     equ 50h
char_S     equ 6dh
char_u     equ 1ch
char_Y     equ 6eh
;; specialni znaky
;
char_blank equ 00h	
char_minus equ 40h
;
	org 	8000h
init:	jmp	dale
tabul:	db	char_0,char_1,char_2,char_3,char_4,char_5,char_6,char_7,char_8,char_9,char_A,char_b,char_C,char_d,char_E,char_F
dale:	mov	DPTR,#tabul
	mov	R7,#16
	mov	R1,#3fh
jedem:
	mov	A,R7
	movc	A,@A+DPTR
	mov	@R1,A
	dec	R1
	djnz	R7,jedem

	;hlavni smycka
	;R5,6,7=neco
	mov	R5,#3
	mov	R6,#6
	mov	R7,#0ah	
nekonecno:
	call	vysli
	jmp	nekonecno

vysli:
	mov	acc,#30h
	add	A,R7
	mov	R1,A
	mov	A,@R1 
	mov	20h,A
	call	vysli1
	call	vysli0
	mov	C,6
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
	mov	C,5
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
	mov	C,4
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
	mov	C,3
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
	mov	C,2
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
	mov	C,1
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
	mov	C,0
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
; doted vyslano 9 bitu
	mov	acc,#30h
	add	A,R6
	mov	R1,A
	mov	A,@R1 
	mov	20h,A
	setb	P1.0
	clr	P1.0
	setb	P1.0
	clr	P1.0
	setb	P1.0
	clr	P1.0

	mov	C,6
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

	mov	C,5
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

	mov	C,4
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

	mov	C,3
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

	setb	P1.0
	clr	P1.0
	setb	P1.0
	clr	P1.0
; tady uz je vyslano 18 bitu
	setb	P1.0
	clr	P1.0
	setb	P1.0
	clr	P1.0


	mov	C,2
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
	

	mov	C,1
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
	

	mov	C,0
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
; sem uz 2 sedmisegmentovky
	mov	acc,#30h
	add	A,R5
	mov	R1,A
	mov	A,@R1 
	mov	20h,A

	mov	C,6
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

	mov	C,5
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

	mov	C,4
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

	setb	P1.0
	clr	P1.0

	mov	C,3
	mov	P1.1,C
	setb	P1.0
	clr	P1.0


	setb	P1.0
	clr	P1.0
	setb	P1.0
	clr	P1.0

	mov	C,2
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

	mov	C,1
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

	mov	C,0
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

	setb	P1.0
	clr	P1.0
	setb	P1.0
	clr	P1.0
	setb	P1.0
	clr	P1.0

	ret


vysli0:
	clr	P1.1
	setb	P1.0
	clr	P1.0
	ret
vysli1:
	setb	P1.1
	setb	P1.0
	clr	P1.0
	ret

	

	END