
;xmyslik@cslab
;herczeq@feld.cvut.cz
;spusteni/stopnuti citani se provede tlacitky 3 a 4
; tlacitka 1 a 2 pri zastavenem stavu porad funguji jako
; increment/decrement



;
;  D I S P L A Y 
;  -------------
;
;
; Pro rizeni sedmisegmentoveho displeje na pripravcich je pouzit
; obvod M5480B7. Obvod obsahuje posuvny registr a zachytny registr, jehoz
; vystupy primo ovladaji jednotlive segmentovky displeje. Data (to, co
; pozadujeme na displeji zobrazit) vstupuji do obvodu seriove pres bity
; P1.0 (hodiny) a P1.1 (seriova data). Jednotlive bity se zapisuji
; nabeznou hranou hodinoveho signalu.
;
; Seriova data maji konstantni delku 36 bitu. Prvni bit je vzdy jednickovy
; a ridi prepsani informace z posuvneho registru do zachytneho registru.
; K prepsani dojde tehdy, kdyz se tento bit dostane na konec posuvneho
; registru (tzn. kdyz vsech 36 bitu je jiz v posuvnem registru). Tim se
; zamezuje problikavani segmentu behem zapisu dat.
;
; Data maji nasledujici strukturu:
;
;      1 X g3 f3 e3 d3 c3 b3 a3  X X X g2 f2 e2 d2 X X ...
;      X X c2 b2 a2 g1 f1 e1  X d1 X X c1 b1 a1  X X X
;
; 1 - log. 1
; X - znamena: na tomto bitu nezalezi (muze byt 0 nebo 1).
; a,...,g - segmenty dle obr.
;
;
;   segmentovka 3    segmentovka 2    segmentovka 1
;   --------------   --------------   --------------
;  |       a3     | |      a2      | |       a1     |
;  |      ----    | |      ----    | |       ----   |
;  |  f3 /g3 / b3 | |  f2 /g2 / b2 | |  f1 /g1 / b1 |
;  |     ----     | |     ----     | |     ----     |
;  | e3 /   / c3  | | e2 /   / c2  | | e1 /   / c1  |
;  |    ----      | |    ----      | |    ----      |
;  |     d3       | |     d2       | |     d1       |
;   --------------   --------------   --------------
;
;       !!! DESETINNE TECKY NEJSOU ZAPOJENY !!!
;
; TVARY ZNAKU
;
; format: 
;                       | x | g | f | e | d | c | b | a |
;  napr.: char_0 = 3fh  | 0 | 0 | 1 | 1 | 1 | 1 | 1 | 1 |
;
; cisla
;
char_0     equ 3fh
char_1     equ 06h
char_2     equ 5bh
char_3     equ 4fh
char_4     equ 66h
char_5     equ 6dh
char_6     equ 7dh
char_7    equ 07h
char_8     equ 7fh
char_9     equ 6fh 
;
; pismena
;
char_A     equ 77h
char_b     equ 7ch
char_C     equ 39h
char_d     equ 5eh
char_E    equ 79h
char_F     equ 71h
char_H     equ 76h
char_J     equ 1Fh
char_L     equ 38h
char_n     equ 54h
char_o     equ 5ch
char_P     equ 63h
char_r     equ 50h
char_S     equ 6dh
char_u     equ 1ch
char_Y     equ 6eh
;; specialni znaky
;
char_blank equ 00h	
char_minus equ 40h
;
	org 	8000h
init:	jmp	dale
; tohle preruseni je od 8003h
preruseni:
	mov	TCON,#10h
	xch	a,R7
	mov	a,TL0
	rr	A
	rr	A
	rr	A
	rr	A
	anl	a,#0fh
	mov	R6,A
	
	mov	a,TL0
	anl	a,#0fh
	mov	R5,a
	
	mov	a,TH0
	anl	a,#0fh
	xch	a,R7
	
	mov	TH0,#0
	mov	TL0,#0	
	mov	TCON,#11h
	reti


tabul:	db	char_0,char_1,char_2,char_3,char_4,char_5,char_6,char_7,char_8,char_9,char_A,char_b,char_C,char_d,char_E,char_F



tlacitka:
; nulovani prvnich dvou bitove orient bytu
	mov	a,0
	mov	r0,#20h
	mov	@r1,a
	inc	r0
	mov	@r1,a

; nastaveni cteni klavesnice
	setb	p1.7
	setb	p1.4
	setb	p1.5
;tlacitko 1
	clr	p1.6
	mov	c,p1.5
	mov	0,c
;tlacitko 2
	mov	c,p1.4
	mov	2,c
;tlacitko 3
	setb	p1.6
	clr	p1.7
	mov	c,p1.4
	mov	4,c
;tlacitko 4
	mov	c,p1.5
	mov	6,c
	
	
	
	
	
zakmity:

	mov	R2,#016h
z2:	mov	R1,#020h
z1:	
	

	mov	r0,#20h
	mov	a,@r0
	
; nastaveni cteni klavesnice
	setb	p1.7
	setb	p1.4
	setb	p1.5
;tlacitko 1
	clr	p1.6
	mov	c,p1.5
	mov	0,c
;tlacitko 2
	mov	c,p1.4
	mov	2,c
;tlacitko 3
	setb	p1.6
	clr	p1.7
	mov	c,p1.4
	mov	4,c
;tlacitko 4
	mov	c,p1.5
	mov	6,c
	
	xrl	a,@r0
	rl	a
	anl	a,#0aah
	orl	a,@r0
	mov	@r0,a

	djnz	R1,z1
	djnz	R2,z2		
	mov	a,@r0
	xrl	a,#055h
	mov	@r0,a	
	ret













dale:	

	;hlavni smycka
	;R5,6,7=neco
	mov	R7,#0
	mov	R6,#0
	mov	R5,#0

nekonecno:
	
	call	vysli
	call	tlacitka
;test zakmitu
	mov	c,1
	jc	nekonecno
	mov	c,3
	jc	nekonecno
	


	mov	c,0
	jc	jeddolu
	mov	c,2
	jc	jednahoru
	mov	c,4
	mov	P1.2,c
	jc	konecirq
	mov	c,6
	mov	P1.3,C
	jnc	nekonecno
	
	
	
	mov	TMOD,#81h
	mov	IE,#81h
	mov	TCON,#11h	
	
	
	
	
	jmp	nekonecno
konecirq:
	mov	IE,#0
	jmp	nekonecno



;######################################################


jeddolu:
	call	dolu
	call	vysli
	mov	R4,#30h
dolucekej:
	call	tlacitka
	mov	c,1
	jc	nekonecno
	mov	c,0
	jnc	nekonecno
	djnz	R4,dolucekej



doluopak:
	call	tlacitka
	mov	c,1
	jc	nekonecno
	mov	c,0
	jnc	nekonecno
	call	dolu
	call	vysli
	jmp	doluopak
	


;#######################################################

jednahoru:
	call	nahoru
	call	vysli
	mov	R4,#30h
nahorucekej:
	call	tlacitka
	mov	c,3
	jc	nekonecno
	mov	c,2
	jnc	nekonecno
	djnz	R4,nahorucekej



nahoruopak:
	call	tlacitka
	mov	c,3
	jc	nekonecno
	mov	c,2
	jnc	nekonecno
	call	nahoru
	call	vysli
	jmp	nahoruopak
	


;######################################################



dolu:	mov	a,#1
	dec	r5
	add	a,r5
	jc	dw1
	ret	
dw1:	mov	a,#1
	mov	r5,#9
	dec	r6
	add	a,r6
	jc	dw2
	ret
dw2:	mov	a,#1
	mov	r6,#9
	dec	r7
	add	a,r7
	jc	dw3
	ret
dw3:	mov	r7,#9
	ret


;#########################################################



nahoru:	mov	a,#246
	inc	r5
	add	a,r5
	jc	dw_1
	ret
	
dw_1:	mov	a,#246
	mov	r5,#0
	inc	r6
	add	a,r6
	jc	dw_2
	ret

dw_2:	mov	a,#246
	mov	r6,#0
	inc	r7
	add	a,r7
	jc	dw_3
	ret
dw_3:	mov	r7,#0
	ret




; tady se ceka ################################


;wait:	
;mov	R0,#0ffh
;cekej2:	mov	R1,#0ffh
;cekej:	nop
;	nop
;	nop
;	djnz	R1,cekej
;	djnz	R0,cekej2		
;	ret

; tady se ceka ################################

vysli:

	mov	DPTR,#tabul
	mov	R1,#20h
	mov	A,R7
	movc	A,@A+DPTR
	mov	@R1,A



;0. bit - pred synchronizaci
	clr	P1.1
	setb	P1.0
	clr	P1.0


;1. - uvodni 1 
	setb	P1.1
	setb	P1.0
	clr	P1.0
;2.- za tim X
	setb	P1.0
	clr	P1.0
;3.- G3
	mov	C,6
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;4.- F3
	mov	C,5
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;5.- E3
	mov	C,4
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;6.- D3
	mov	C,3
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;7.- C3
	mov	C,2
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;8.- B3
	mov	C,1
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;9.- A3
	mov	C,0
	mov	P1.1,C
	setb	P1.0
	clr	P1.0

; ############## doted vyslano 9 bitu ########################
;	mov	DPTR,#8003h
	mov	R1,#20h
	mov	A,R6
	movc	A,@A+DPTR
	mov	@R1,A


;10.- X
	setb	P1.0
	clr	P1.0
;11.- X
	setb	P1.0
	clr	P1.0
;12.- X
	setb	P1.0
	clr	P1.0
;13.- G2
	mov	C,6
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;14.- F2
	mov	C,5
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;15.- E2
	mov	C,4
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;16.- D2
	mov	C,3
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;17.- X
	setb	P1.0
	clr	P1.0
;18.- X
	setb	P1.0
	clr	P1.0
; ################# tady uz je vyslano 18 bitu ##################
;19.- X
	setb	P1.0
	clr	P1.0
;20.- X
	setb	P1.0
	clr	P1.0
;21.- C2
	mov	C,2
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;22.- B2
	mov	C,1
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;23.- A2
	mov	C,0
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
; ########### sem uz 2 sedmisegmentovky ###############
;	mov	DPTR,#8003h
	mov	R1,#20h
	mov	A,R5
	movc	A,@A+DPTR
	mov	@R1,A
;24.- G1
	mov	C,6
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;25.- F1
	mov	C,5
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;26.- E1
	mov	C,4
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;27.- X
	setb	P1.0
	clr	P1.0
;28.- D1
	mov	C,3
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;29.- X
	setb	P1.0
	clr	P1.0
;30.- X
	setb	P1.0
	clr	P1.0
;31.- C1
	mov	C,2
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;32.- B1
	mov	C,1
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;33.- A1
	mov	C,0
	mov	P1.1,C
	setb	P1.0
	clr	P1.0
;34.- X
	clr	P1.0
	setb	P1.0
;35.- X
	clr	P1.0
	setb	P1.0
;36.- X
	clr	P1.0
	setb	P1.0


	ret

	END